<template>
  <v-app>
  <v-data-table
    v-model="selected"
    :headers="headers"
    :items="desserts"
    :single-select="singleSelect"
    item-key="ID"
    show-select
    style="padding:25px">

    <template v-slot:top>
      <div>
          <div>
            <v-toolbar style="box-shadow:none !important">
              <v-toolbar-title><b>{{title}}</b></v-toolbar-title>
              <v-spacer></v-spacer>
              
              <v-spacer></v-spacer>

              <v-btn rounded style="margin-top:15px;margin-right:5px" color="primary" large v-on:click="modalForm()">
                  <v-icon dark style="margin-right:10px">search</v-icon>
                  Filter
              </v-btn>
              <v-btn rounded style="margin-top:15px;" color="default" large v-on:click="alldata()">
                <v-icon dark>refresh</v-icon>
              </v-btn>
            </v-toolbar>
        </div>
      </div>

      <br><br>
      <v-dialog
        v-model="modal_form"
        max-width="1000px"
      >
        <v-card>
          <v-card-title>
            SLA Filter
          </v-card-title>
          <v-card-text>
              <v-form
                ref="form"
                v-model="valid"
                lazy-validation
              >
                  <div style="padding:10px">
                      <v-layout row>
                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-menu
                                          ref="menu"
                                          v-model="menu"
                                          :close-on-content-click="false"
                                          :return-value.sync="date"
                                          transition="scale-transition"
                                          offset-y
                                          min-width="290px"
                                        >
                                          <template v-slot:activator="{ on }">
                                            <v-text-field
                                              v-model="date"
                                              label="Start Date"
                                              append-icon="event"
                                              readonly
                                              v-on="on"
                                            ></v-text-field>
                                          </template>
                                          <v-date-picker v-model="date" no-title scrollable>
                                            <v-spacer></v-spacer>
                                            <v-btn text color="primary" @click="menu = false">Cancel</v-btn>
                                            <v-btn text color="primary" @click="$refs.menu.save(date)">OK</v-btn>
                                          </v-date-picker>
                                        </v-menu>
                                    </div>
                              </v-flex>

                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-menu
                                        ref="menu2"
                                        v-model="menu2"
                                        :close-on-content-click="false"
                                        :return-value.sync="date2"
                                        transition="scale-transition"
                                        offset-y
                                        min-width="290px"
                                      >
                                        <template v-slot:activator="{ on }">
                                          <v-text-field
                                            v-model="date2"
                                            label="End Date"
                                            append-icon="event"
                                            readonly
                                            v-on="on"
                                          ></v-text-field>
                                        </template>
                                        <v-date-picker v-model="date2" no-title scrollable>
                                          <v-spacer></v-spacer>
                                          <v-btn text color="primary" @click="menu2 = false">Cancel</v-btn>
                                          <v-btn text color="primary" @click="$refs.menu2.save(date2)">OK</v-btn>
                                        </v-date-picker>
                                      </v-menu>
                                  </div>   
                              </v-flex>


                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-autocomplete 
                                        item-text="COMPANY_NAME"
                                        item-value="COMPANY_ID"
                                        v-model="company_id" 
                                        :items="list_company"
                                        label="Choose Company"
                                        v-bind:value="{ id: COMPANY_ID, text: COMPANY_NAME }"
                                      ></v-autocomplete>
                                  </div>   
                              </v-flex>


                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-autocomplete 
                                        item-text="NAME"
                                        item-value="USER_ID"
                                        v-model="approval1" 
                                        :items="list_approval1"
                                        label="Choose Approval 1"
                                      ></v-autocomplete>
                                  </div>   
                              </v-flex>


                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-autocomplete 
                                        item-text="NAME"
                                        item-value="USER_ID"
                                        v-model="approval2" 
                                        :items="list_approval2"
                                        label="Choose Approval 2"
                                      ></v-autocomplete>
                                  </div>   
                              </v-flex>

                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-autocomplete 
                                        item-text="NAME"
                                        item-value="USER_ID"
                                        v-model="cataloguer" 
                                        :items="list_cataloguer"
                                        label="Choose Cataloguer"
                                      ></v-autocomplete>
                                  </div>   
                              </v-flex>

                               <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-text-field 
                                        v-model="request_no" 
                                        label="Request Number"
                                        append-icon="mdi-card-text"
                                      ></v-text-field>
                                  </div>   
                              </v-flex>

                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:10px">
                                      <v-text-field 
                                        v-model="item_name" 
                                        label="Item Name"
                                        append-icon="mdi-folder-table"
                                      ></v-text-field>
                                  </div>   
                              </v-flex>

                              <v-flex md3>
                                  <div style="margin-left:20px;padding-top:20px">
                                    <v-btn color="primary" v-on:click="search()">
                                      Search
                                    </v-btn>
                                    &nbsp;

                                    <v-btn color="success" dark v-on:click="alldata()">
                                      All
                                    </v-btn>
                                  </div>
                              </v-flex>
                        </v-layout>
                  </div>
                        
                  <div align="right">

                      <v-btn
                      color="primary"
                      text
                      @click="modal_form = false"
                      >
                        Close
                      </v-btn>
                </div>
            </v-form>
          </v-card-text>
        </v-card>
      </v-dialog>
    </template>

    <template v-slot:item.approval1="{ item }">
        <div>{{item.APPROVAL1}}</div>
        <div>{{item.APPROVAL1_DATES}}</div>
        <b v-if="item.APPROVAL1_DATE">{{item.APPROVAL1_DATE}} Days</b>
        <div v-if="item.TYPE_STOCK=='N'">No Approval 1 <br><b>Non Stock</b></div>
    </template>

    <template v-slot:item.approval2="{ item }">
        <div>{{item.APPROVAL2}}</div>
        <div>{{item.APPROVAL2_DATES}}</div>
        <b v-if="item.APPROVAL2_DATE">{{item.APPROVAL2_DATE}} Days</b>
       <div v-if="item.TYPE_STOCK=='N'">No Approval 2 <br><b>Non Stock</b></div>
        
    </template>

    <template v-slot:item.cataloguer="{ item }">
        <div>{{item.CATALOGUER}}</div>
        <div>{{item.CATALOGUER_DATES}}</div>
        <b v-if="item.CATALOGUER_DATE =='0' ||  item.CATALOGUER_DATE">{{item.CATALOGUER_DATE}} Days</b> 
    </template>

    <template v-slot:item.total="{ item }">
        <b >{{item.APPROVAL1_DATE + item.APPROVAL2_DATE + item.CATALOGUER_DATE}} Days</b>
    </template>

  </v-data-table>
  </v-app>
</template>



<script>
export default {
    methods: {
      getData(){
          var self = this;
          var url  = self.base_url + "dashboard/sla_admin";

          self.axios.post(url , {
              departement_id : self.storage_departement_id,
              company : self.company_id,
              startdate : self.date,
              enddate : self.date2,
              requester : self.storage_user_id,
              approval1 : self.approval1,
              approval2 : self.approval2,
              cataloguer : self.cataloguer,
              item_name : self.item_name,
              request_no : self.request_no
          })
          .then(function (response) {
              self.desserts = response.data;
          });
      },
      getCompany(){ 
          var self = this;
          //self.storage_location = '';
          var url = this.base_url + "dropdown/company_dashboard_all"; 
          this.axios.get(url).then(function (response) {
            self.list_company = response.data;
          });
      },
      alldata(){
        var self = this;
        self.company_id = "";
        self.date = "";
        self.date2 = "";
        self.requester = "";
        self.approval1 = "";
        self.approval2 = "";
        self.cataloguer = "";
        self.item_name = "";
        self.request_no = "";
        self.getData();
        self.modal_form = false;
      },
      getRequester(){
        var self = this;
        var url = self.base_url + "dropdown/requester";
        self.axios.get(url).then(function (response) {
            self.list_requester = response.data;
        })
      },
      getApproval1(){
        var self = this;
        var url = self.base_url + "dropdown/approval1";
        self.axios.get(url).then(function (response) {
            self.list_approval1 = response.data;
        })
      },
      getApproval2(){
        var self = this;
        var url = self.base_url + "dropdown/approval2";
        self.axios.get(url).then(function (response) {
            self.list_approval2 = response.data;
        })
      },
      getCataloguer(){
        var self = this;
        var url = self.base_url + "dropdown/cataloguer";
        self.axios.get(url).then(function (response) {
            self.list_cataloguer = response.data;
        })
      },
      search(){
         var self = this;
         self.getData();
         self.modal_form = false;
      },
      modalForm(){
        var self = this;
        self.modal_form = true;
        self.disabled = false;
        //self.reset();
      },
      getDepartement(){
          var self = this;
          var url = self.base_url + "dropdown/departement_dashboard";
          self.axios.get(url).then(function (response) {
              self.list_departement = response.data;
          })
      },
      getDateMonth(){
        var today=new Date()
        var year=today.getFullYear()
        var month=today.getMonth()
        var date=today.getDate()
        if((month-1)<=0)
        year=today.getFullYear()
        var backdate = new Date(year,month-1,date).toISOString().substr(0, 10);
        this.date = backdate;
      }
    },
    mounted(){
        
        if(this.storage_role !='REQ' && this.storage_role !='ADM'){
          this.$router.push('/login'); 
        }
        
         this.getDateMonth();
         this.getDepartement();
         this.getData(); 
         this.getCompany();
         this.getRequester();
         this.getApproval1();
         this.getApproval2();
         this.getCataloguer();  
    },
    data () { 
      return {
        name : "SLA Report",
        title : "SLA Report",
        modal_form: false,
        items: [],
        desserts : [],
        headers: [
          { text: 'Request Number', value: 'REQUEST_CODE',width:"150"},
          { text: 'Departement', value: 'DEPARTEMENT_ID',width:"150"},
          { text: 'Requester', value: 'REQUESTER',width:"190"},
          { text: 'Item Name', value: 'INC',width:"250"},
          { text: 'Request Date', value: 'REQUEST_DATE',width:"180"},
          { text: 'Submit Date', value: 'SUBMIT_DATE',width:"180"},
          { text: 'Approval 1', value: 'approval1',width:"180"},
          { text: 'Approval 2', value: 'approval2',width:"180"},
          { text: 'Cataloguer', value: 'cataloguer',width:"180"},
          { text: 'Total LT', value: 'total',width:"150"},
          { text: 'Status', value: 'STATUS_DESC',width:"280"}
        ],
        list_departement : [{DEPARTEMENT_ID:'',DEPARTEMENT_NAME:'All Departement'}],
        ist_company : [{COMPANY_ID:'',COMPANY_NAME:'All Company'}],
        list_server_code : [],
        list_requester : [],
        list_approval1 : [],
        list_approval2 : [],
        list_cataloguer : [],
        departement_id:"",
        company_id : "",
        date: "",
        date2:new Date().toISOString().substr(0, 10),
        requester : "",
        approval1 : "",
        approval2 : "",
        cataloguer : "",
        item_name : "",
        request_no : "",

        //storage.....................................
        storage_user_id : atob(localStorage.getItem("user_id")),
        storage_username : atob(localStorage.getItem("username")),
        storage_fullname : atob(localStorage.getItem("fullname")),
        storage_company_id : atob(localStorage.getItem("company_id")),
        storage_company_name : atob(localStorage.getItem("company_name")),
        storage_role : atob(localStorage.getItem("role")),
        storage_server : atob(localStorage.getItem("server")),
        storage_departement_id : atob(localStorage.getItem("departement_id")),
      }
    },
  }
</script>
